#include <bits/stdc++.h>
using namespace std;

int main()
{
    int n,q;
    int a[100];
    cin>>n>>q;
    for(int i = 0; i<n; i++){
        cin>>a[i];

    }
    int k,l;
    for(int i=0;i<q;i++){
        cin>>k>>l;
        k--;l--;
        int b=0;int max=0;
        if(l-k==1){
          if(a[l]&a[k]>a[l]^a[k]){
              cout<<1<<endl;
            }
        }else{
        for(int j=k;j<l;j++){
            b=0;
            for(int f=j+1; f<l; f++){
                if(a[j]&a[f]>a[j]^a[f]){
                    b++;
                }
            }
            if(b>max){
                max=b;
            }
        }
        cout<<max<<endl;}
    }
    return 0;
}